MODEL TINY
STACK 256
DATASEG
	msg1 DB 10,10,'Tomas Urbanavicius, MIF III kursas 3 grupe','$'
	msg2 DB 10,'11. Eilutes tekste rastus skaicius pakeisti i dvejetaini formata',10,'$'
	msg3 DB 10,'Iveskite eilute:',10,'$'
	msg4 DB 10,'Pakeista eilute:',10,'$'
	string DB 120 DUP(0)	; apsirasome eilute, 120 simboliu
	len_string=$-string
CODESEG
start:
	mov ax,@data		; nurodo duomenu segmento pradzia
	mov ds,ax
	mov dx,offset msg1	; isvedame pirma pranesima
	mov ah,09h		; Eilutes isvedimo funkcija
	int 21h
	mov dx,offset msg2	; isvedame antra pranesima
	mov ah,09h		; Eilutes isvedimo funkcija
	int 21h
	mov dx,offset msg3	; isvedame trecia pranesima
	mov ah,09h		; Eilutes isvedimo funkcija
	int 21h
	mov bx,0		; Nurodom kad skaitimas vyks is klaviaturos
	mov cx,len_string	; string ilgis
	lea dx,string		; Nurodom string adresa atminti, cia bus rasomi duomenys
	mov ah,3fh		; skaitimo  funkcija (is failo, klaviaturos ar dar kur nors)
	int 21h
	mov cx,ax		; AL - kiek simboliu buvo ivesta
	mov dx,offset msg4	; isvedame ketvirta pranesima
	mov ah,09h		; Eilutes isvedimo funkcija
	int 21h
	lea si,string		; formuojame adresa i eilute
	xor ax,ax		; ax = 0
m1:
	xor dx,dx		; dx = 0
	mov dl,[si]		; [si] taip rasomas adresas
				; cia perduodam pirma eilutes simboli (is string)
	cmp dl,'0'		; ar  dl priklauso['0';'9'] intervalui
	jb  m_func		; jump below
	cmp dl,':'
	jae  m_func		; jump above or equal; jei ne sokam i m_func
				;--- 1 start --- jeigu dabartinis simbolis skaicius
	push dx			; Issaugom DX registra (jame simbolis)
	and dl,0fh		; (keiciam dx registra) verciam ASCII -> INT
	add ax,dx		; Sudarom skaciu PVZ: '53' 5*10+3 (tokia schema)
	mov bl,10		; daugyba
				; - tikriname ar kitas simb. ne sk., jei taip, tada simb*10
	inc si			; pointeri pajudinam per viena simboli
	mov dl,[si]
				; cia perduodam pointeris i string elementa (is string)
	cmp dl,'0'		; ar  dl priklauso['0';'9'] intervalui
	jb  daugyba
	cmp dl,':'
	jae  daugyba		; jei ne sokam i m_func
	mul bl			; DAUGYBA, jeigu paskutinis skaitmu tai nedauginam jo
daugyba:
	dec si			; Pamazinam pointeri per viena simboli
m_func:
 				; cia atsiduriame, jei esamas simb. ne sk., o pries tai buves - sk.
	pop dx			; Grazinam DX registra 
	cmp dl,'0'		; ar  dl priklauso['0';'9'] intervalui
	jb  m1_lyg1		; jei ne, tai sokam i m1_lyg1
	cmp dl,':'
	jbe  m1_rep		; jei taip sokam i m1_rep
m1_lyg1:
				; Jeigu po skaitmens simbolis tai isvedam musu israuta skaiciu BIN formate
	cmp ax,0		; O gal skaicius 0 , tai jo nevesim
	je  m1_rep
	cmp ax,0ffh		; O gal skaicius didesnis uz 255, tai jo irgi nevesim
	ja  m1_rep0
	push ax			; issaugome steke registr ax
	mov dl,'('		; isvedame skliaustelius pries dvejetaini sk.
	mov ah,02h
	int 21h
	pop ax			; paimame is steko issaugota registra ax
	mov dx,ax		; Kagi vedam INT->BIN
	CALL itob
	xor dx,dx		; RESET: dx=0
	mov dl,')'		
				; isvedame skliaustelius po dvejetainio sk.
	mov ah,02h
	int 21h
m1_rep0:
	mov ax,0
m1_rep:
	push ax			; issaugome steke registr ax
	mov dl,[si]		; i dl ikeliame simboli
	mov ah,02h		; jei ne skaicius, tai isvedame raide
	int 21h
	pop ax			; paimame is steko issaugota registra ax
	dec cx			; Mazinam CX skaitliuka (nurodo kada baigti cikla)
	inc si			; Pajudinam pointeri per viena baita (STRING)
	cmp cx,1		; CIKLO PABAIGA
	jb  m1_end		; JUMPER BELOW
	jmp m1			; CIKLAS
m1_end:
	mov ah, 04ch
	mov al, 0h
	int 21h
itob    PROC			; Desimtainis=>Dvejetainis
				; ISSAUGOM REGISTRUS
	push bx
	push cx
	push ax
	push dx
	mov bl,2		; Daliklis
	mov cx,0		; Skaitliukas
bin:
	mov ax,dx		; Skaicius arba jo likutis po vieno ciklo
	div bl			; Dalyba is 2
	push ax			; Dalybos rezultatas i steka
	inc cx			; Kiek tu rezultatu ?
	cmp al,0		; Kol nesibaige skaicius
	je  end_bin		; Jei baigesi
	mov dl,al		; Jei ne dl permetame skaiciaus likuti
	jmp bin			; CIKLAS
end_bin:
print:
	pop ax			; Isvedam steka
	mov dl,ah		; dl - parametras(isvedimui) ah - liekana (0,1)
	or dx,03030h		; 1 arba 0 verciam i ASCII
	mov ah,02h		; simbolio isvedimo funkcija
	int 21h
	dec cx			; Sumazinam skaitliuka
	cmp cx,0		; Jeigu daugiau nera ka isvedineti
	je end_print		; Baigiam
	jmp print		; CIKLAS
end_print:
				; GRAZINAM REGISTRUS
	pop dx
	pop ax
	pop cx
	pop bx
	ret
itob  ENDP
;----------------------------------------------------------------------------------
end start
